package com.sun.jmx.snmp.agent;

import com.sun.jmx.snmp.SnmpStatusException;
import java.io.Serializable;

public abstract class SnmpMibEntry extends SnmpMibNode implements Serializable
{
    public SnmpMibEntry() {
    }
    
    public abstract boolean isVariable(long p0);
    
    public abstract boolean isReadable(long p0);
    
    @Override
    public long getNextVarId(long n, Object o) throws SnmpStatusException {
        long n2;
        for (n2 = super.getNextVarId(n, o); !this.isReadable(n2); n2 = super.getNextVarId(n2, o)) {}
        return n2;
    }
    
    public void validateVarId(long n, Object o) throws SnmpStatusException {
        if (!this.isVariable(n)) {
            throw new SnmpStatusException(2);
        }
        return;
    }
    
    @Override
    public abstract void get(SnmpMibSubRequest p0, int p1) throws SnmpStatusException;
    
    @Override
    public abstract void set(SnmpMibSubRequest p0, int p1) throws SnmpStatusException;
    
    @Override
    public abstract void check(SnmpMibSubRequest p0, int p1) throws SnmpStatusException;
}
